require 'rubyfltk.so'

module Fltk
  module Drawable
    def color(c)
      Fltk::color(c)
    end

    def clear
      color(Fltk::GRAY)
      rectf(0, 0, self.w, self.h)
    end

    def fill(c)
      color(c)
      rectf(0, 0, self.w, self.h)
    end

    def push_clip(x, y, w, h)
      Fltk::push_clip(realx(x), realy(y), w, h)
    end

    def push_no_clip
      Fltk::push_no_clip
    end

    def pop_clip
      Fltk::pop_clip
    end

    def not_clipped(x, y, w, h)
      Fltk::not_clipped(realx(x), realy(y), w, h)
    end
    alias not_clipped? not_clipped

    def clip_box(x, y, w, h)
      Fltk::clip_box(realx(x), realy(y), w, h)
    end

    def line_style(style, width = 0, dashes = nil)
      Fltk::line_style(style, width, dashes)
    end

    def point(x,y)
      Fltk::point(realx(x), realy(y))
    end
    
    def line(x1,y1,x2,y2)
      Fltk::line(realx(x1), realy(y1), realx(x2), realy(y2))
    end
    
    def rect(x,y,w,h)
      Fltk::rect(realx(x), realy(y), w, h)
    end
	
    def rectf(x,y,w,h)
      Fltk::rectf(realx(x), realy(y), w, h)
    end
	
    def pie(x,y,w,h,a1,a2)
      Fltk::pie(realx(x), realy(y), w, h, a1, a2)
    end

    def text_draw(text,x,y,w=nil,h=nil,align=nil)
      if( w && h && align )
	Fltk::draw(text,realx(x),realy(y),w,h,align)
      elsif( w && h && !align )
	Fltk::draw(text,realx(x),realy(y),w,h)
      elsif( !w && !h && !align )
	Fltk::draw(text,realx(x),realy(y))
      else
	raise(ArgumentError, "wrong argument")
      end
    end

    def text_width(text, n = nil)
      if( n )
	Fltk.width(text, n)
      else
	Fltk.width(text)
      end
    end

    def realx(x)
      return self.x + x
    end
    
    def realy(y)
      return self.y + y
    end
  end
end
