require 'fltk'

class RadioButton < Fltk::RoundButton
	def initialize(label, &onChange)
		size(80,20)
		button_type(Fltk::RADIO_BUTTON)
		callback(&onChange)
	end
end

class MyWindow < Fltk::Window
	def initialize
		super(300, 300, 'Radio Buttons')
		
		vpack = Fltk::Pack.new(w,h)
	
		title = Fltk::Box.new(200,20,'Choose a color:')
		#title.align(Fltk::ALIGN_LEFT)
		RadioButton.new('Red') do onSetColor(Fltk::RED) end
		RadioButton.new('Green') do onSetColor(Fltk::GREEN) end
		RadioButton.new('Blue') do onSetColor(Fltk::BLUE) end
		
		@preview = Fltk::Box.new(300,100,'Preview')
		@preview.box(Fltk::FLAT_BOX)

	end
	
	def onSetColor(color)
		@preview.color(color)
		@preview.redraw
	end
	
end

MyWindow.new.show
Fltk::run
