require 'fltk'

class WaveWidget < Fltk::Widget
  include Fltk::Drawable

  SIZEX = 1000
  SIZEY = 400
  def initialize
    size(SIZEX,SIZEY)
  end
  
  def draw
    clear
    SIZEX.times do | i |
      x = i * 2 * 3.1415927 / SIZEX
      y = Math.sin(x)
      color(Fltk::BLACK)
      point(i,y*SIZEY/2+SIZEY/2)
    end
  end
end

class MyWindow < Fltk::DoubleWindow
  def initialize
    super(300, 300, 'Scrolling')
    pack = Fltk::Pack.new(w,h)
    title = Fltk::Box.new(80, 20, 'Sine Wave')
    title.box(Fltk::BORDER_BOX)
    pane = Fltk::Scroll.new(w,h-20)
    pack.resizable(pane)
    wave = WaveWidget.new
    resizable(pack)
  end
end

MyWindow.new.show
Fltk::run
