require 'fltk'

class MainWindow < Fltk::Window
	def initialize
		super(300,300,'Lists')
		Fltk::Pack.new(300,300)
		
		pack = Fltk::Pack.new(300,200)
		pack.pack_type(Fltk::HORIZONTAL)
		createReadonlyList(['This', 'is', 'read', 'only'])
		single = createSingleSelectList(['Single', 'selection', 'here'])
		multi = createMultiSelectList(['Multiple', 'selections', 
			'allowed', 'with', 	'ctrl-click,', 'shift-click,', 'and', 'drag'])
		pack.group_end

		btn = Fltk::Button.new(100,20,'Left Results')
		btn.callback do Fltk::message("Nothing selected") end
		btn = Fltk::Button.new(100,20,'Middle Results')
		btn.callback do onShowSingle(single) end
		btn = Fltk::Button.new(100,20,'Right Results')
		btn.callback do onShowMulti(multi) end
	end
	
	def createReadonlyList(items)
		list = Fltk::Browser.new(100,300)
		items.each do | item | list.add(item) end
		return list
	end
	
	def createSingleSelectList(items)
		list = Fltk::HoldBrowser.new(100,300)
		items.each do | item | list.add(item) end
		return list
	end
	
	def createMultiSelectList(items)
		list = Fltk::MultiBrowser.new(100,300)
		items.each do | item | list.add(item) end
		return list
	end
	
	def onShowSingle(singleList)
		if(singleList.value > 0)
			Fltk::message("Selected row: #{singleList.value}")
		else
			Fltk::message("Nothing selected")
		end
	end
	
	def onShowMulti(multiList)
		multi = []
		multiList.size.times do | row |
			if(multiList.selected(row+1))
				multi << row+1
			end
		end
		if(multi.size > 0)
			text = "Selected rows: "
			multi.each do |row| text += "#{row} " end
		else
			text = "Nothing selected"
		end
		Fltk::message(text)
	end
end

MainWindow.new.show
Fltk::run
