require 'fltk'

class MainWindow < Fltk::Window
	def initialize
		super(400, 200, 'Main Window')
		Fltk::Pack.new(w,h)
		
		@choices = ['Hamburger', 'Ravioli', 'Pad Thai']
		
		row = Fltk::Pack.new(w,20)
		row.pack_type(Fltk::HORIZONTAL)
		Fltk::Box.new(200, 20, 'Choose your meal:')
		@dropdown = Fltk::Choice.new(100,20)
		row.resizable(@dropdown)
		@dropdown.callback do onChangeOrder end
		@choices.each do | item | @dropdown.add(item) end
		@dropdown.value(0)
		row.group_end
		
		@checkbox = Fltk::CheckButton.new(100,20,'Do you want fries with that?')
		@checkbox.callback do onChangeOrder end
		
		box = Fltk::Box.new(w,2)
		box.box(Fltk::BORDER_BOX)
		
		@order = Fltk::Input.new(w, 20)
		@order.deactivate
		onChangeOrder
	end
	
	def onChangeOrder
		text = "Your Order: #{@choices[@dropdown.value]} "
		if(@checkbox.value > 0)
			text += "with fries"
		end
		@order.value(text)
		nil
	end
end

MainWindow.new.show
Fltk::run
